<?php
namespace Claromentis\Infocapture\Filter;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"] ?: array()) + array("_977995ec9267e034bf7d84b6" . "9939eaef" => base64_decode("TGltaXQgbXVzdCBiZSBhbiBpbnR" . "lZ2VyLCAn"), "_7608a269" . "0229dd26a" . "c43cb60aa" . "2a7d97" => base64_decode("bGFzdF9tb2RpZmllZA" . "=="), "_fb092084478a617" . "534a42360c88e0c9" . "f" => base64_decode("T2Zmc2V0IG11c3QgYmUgYW" . "4gaW50ZWdlciwgJw=="), "_62d701c" . "3c53404f" . "06345eb3" . "5720a47b" . "4" => base64_decode("aXNfbnVtZXJpY" . "w=="), "_f22ff2bb16ab37d1f01d612e668e64d" . "2" => base64_decode("LC" . "An"), "_f1136982" . "4f533e820" . "6f9ccc0c9" . "aab3a0" => base64_decode("bG" . "lt" . "aX" . "Q="), "_aa28ebaa9e17fc6a" . "67b37600d92d6054" => base64_decode("Y3Jl" . "YXRl" . "ZF9k" . "YXRl"), "_1f50e30be8c2fefa6881834e71d504" . "a2" => base64_decode("b2Zmc" . "2V0"), "_b8762acab332819f" . "09c183233ba40aa0" => base64_decode("T2Zmc2V0IGNh" . "bm5vdCBiZSBs" . "ZXNzIHRoYW4g" . "emVybywgJw=="), "_fabe7b83d4fd8" . "1224b2616ff595" . "17e4f" => base64_decode("TGltaXQgbXVzdCBiZSBiZXR3ZWVu" . "IDEgYW5kIA=="), "_fa7fe9b4130a6" . "9a5ebf16164366" . "03e27" => base64_decode("JyBnaXZlbi" . "c="), "sta" . "tus" => base64_decode("c3RhdH" . "Vz"));
use Claromentis\Core\Security\SecurityContext;
use Date;
use InvalidArgumentException;
use Psr\Http\Message\ServerRequestInterface;




abstract class AbstractFilter
{
    public const MAX_LIMIT = 200;
    public const DEFAULT_LIMIT = 20;
    
    
    
    
    protected ?SecurityContext $context = null;
    protected int $limit = self::DEFAULT_LIMIT;
    protected int $offset = 0;
    protected ?Date $created_date = null;
    protected ?Date $modified_date = null;
    protected ?string $status = null;
    public function getContext() : ?SecurityContext
    {
        return $this->context;
    }
    public function setContext(?SecurityContext $context = null) : self
    {
        $this->context = $context;
        return $this;
    }
    public function getLimit() : int
    {
        return $this->limit;
    }
    
    
    
    
    
    
    
    
    public function setLimit(int $_f11369824f533e8206f9ccc0c9aab3a0) : self
    {
        if (!$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_62d701c3c53404f06345eb357" . "20a47b4"]($_f11369824f533e8206f9ccc0c9aab3a0)) {
            throw new InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_977995ec9267e034bf7d" . "84b69939eaef"] . $_f11369824f533e8206f9ccc0c9aab3a0 . $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_fa7fe9b4130a" . "69a5ebf161643" . "6603e27"]);
        }
        $_f11369824f533e8206f9ccc0c9aab3a0 = (int) $_f11369824f533e8206f9ccc0c9aab3a0;
        if ($_f11369824f533e8206f9ccc0c9aab3a0 <= 0 || $_f11369824f533e8206f9ccc0c9aab3a0 > self::MAX_LIMIT) {
            throw new InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_fabe7b83d4fd81224b2616ff59517" . "e4f"] . self::MAX_LIMIT . ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_f22ff2bb16ab37d1f01d612e668e6" . "4d2"] . $_f11369824f533e8206f9ccc0c9aab3a0 . $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_fa7fe9b41" . "30a69a5ebf" . "1616436603" . "e27"]));
        } else {
            $this->limit = $_f11369824f533e8206f9ccc0c9aab3a0;
        }
        return $this;
    }
    public function getOffset() : int
    {
        return $this->offset;
    }
    
    
    
    
    
    
    
    
    public function setOffset(int $_1f50e30be8c2fefa6881834e71d504a2) : self
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_62d701c3" . "c53404f06" . "345eb3572" . "0a47b4"]($_1f50e30be8c2fefa6881834e71d504a2)) {
            throw new InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_fb092084478a61" . "7534a42360c88e0" . "c9f"] . $_1f50e30be8c2fefa6881834e71d504a2 . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_fa7fe9b4130a69a5ebf1616" . "436603e27"]);
        }
        $_1f50e30be8c2fefa6881834e71d504a2 = (int) $_1f50e30be8c2fefa6881834e71d504a2;
        if ($_1f50e30be8c2fefa6881834e71d504a2 < 0) {
            throw new InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_b8762acab332819" . "f09c183233ba40aa" . "0"] . $_1f50e30be8c2fefa6881834e71d504a2 . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_fa7fe9b4130a69a5ebf1" . "616436603e27"]);
        }
        $this->offset = $_1f50e30be8c2fefa6881834e71d504a2;
        return $this;
    }
    public function getCreatedDate() : ?Date
    {
        return $this->created_date;
    }
    public function setCreatedDate(?Date $_aa28ebaa9e17fc6a67b37600d92d6054)
    {
        $this->created_date = $_aa28ebaa9e17fc6a67b37600d92d6054;
    }
    public function getModifiedDate() : ?Date
    {
        return $this->modified_date;
    }
    public function setModifiedDate(?Date $_aeb918f309c1ac9bf44d7449ee69a709)
    {
        $this->modified_date = $_aeb918f309c1ac9bf44d7449ee69a709;
    }
    public function getStatus() : ?string
    {
        return $this->status;
    }
    public function setStatus(?string $status) : void
    {
        $this->status = $status;
    }
    
    
    
    
    
    
    
    
    public function setPaginationAttributesFromRequest(ServerRequestInterface $request) : void
    {
        $parameters = $request->getQueryParams();
        $_1f50e30be8c2fefa6881834e71d504a2 = isset($parameters[$GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_1f50e30be8c2fefa6881834e71d504a" . "2"]]) && $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_62d701c3c53404f063" . "45eb35720a47b4"]($parameters[$GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_1f50e30be8c2fefa" . "6881834e71d504a2"]]) ? (int) $parameters[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_1f50e30be8c2fefa" . "6881834e71d504a2"]] : 0;
        $_f11369824f533e8206f9ccc0c9aab3a0 = isset($parameters[$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_f11369824f533" . "e8206f9ccc0c9a" . "ab3a0"]]) && $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_62d701c3c53404f06345eb35" . "720a47b4"]($parameters[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_f11369824f533e8206f9ccc0" . "c9aab3a0"]]) ? (int) $parameters[$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_f11369824f" . "533e8206f9c" . "cc0c9aab3a0"]] : self::DEFAULT_LIMIT;
        $this->setOffset($_1f50e30be8c2fefa6881834e71d504a2);
        $this->setLimit($_f11369824f533e8206f9ccc0c9aab3a0);
    }
    
    
    
    
    
    
    public function toArray() : array
    {
        return [$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_f11369824f533e8206f9cc" . "c0c9aab3a0"] => $this->limit, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_1f50e30be8c2f" . "efa6881834e71d" . "504a2"] => $this->offset, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_aa28ebaa9e17fc6a67b37600d" . "92d6054"] => $this->created_date, $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_7608a26" . "90229dd2" . "6ac43cb6" . "0aa2a7d9" . "7"] => $this->modified_date, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["sta" . "tus"] => $this->status];
    }
}